<?php
namespace Common\Aide;


/**
 * 跳转其他地址的helper类
 * @author: duanbin
 * @时间: 2016年10月24日 下午5:49:06
 * @version: 1.0
 */
class JumpAide{
	
	protected $info = "";
	
	/**
	 * 获取服务码
	 * @时间: 2016年12月17日 下午3:07:24
	 * @author: duanbin
	 * @param $input_name
	 * @param $api_name
	 * @param $business_id
	 * @param $business_mark
	 * @param $api_access
	 * @return bool|mixed
	 */
	public function get_service_code($input_name,$api_name,$business_id,$business_mark,$api_access){
		$api_access = $api_access + 0;
		$api_access = $api_access == 2 ? $api_access : 1;
		$agent = new \Common\Aide\AgentAide(1,$api_access);
		$t = $agent->servant;
		try{
			$result = $t->get_server_code($input_name,$api_name,$business_mark,$business_id);
			$response_json_obj = json_decode($result,true);
		}catch(\Exception $e){
			$this->info = $e->getMessage();
			return false;
		}
		if(!empty($response_json_obj) && strcmp($response_json_obj['code'],'0') == 0){
			return $response_json_obj;
		}else{
			api_log(session("user_id"),"input_name:".$input_name."-pname:".$api_name."-bis_sign:".$business_mark."-bid:".$business_id,$result,"获取服务码");
			$this->info = '获取服务码失败！';
			return false;
		}
	}
	
	/**
	 * 跳转自助管理平台
	 * @时间: 2016年12月17日 下午3:22:03
	 * @author: duanbin
	 * @param $service
	 * @param $api_access
	 * @return bool|string
	 */
	public function jump_to_ssp($service,$api_access){
		$api_access = $api_access + 0;
		$api_access = $api_access == 2 ? $api_access : 1;
		if(empty($service) || strcmp($service['code'],'0') != 0){
			$this->info = "产品服务码获取失败!";
			return false;
		}
		$service_pwd = $service['info']['passwd'];
		$service_code = $service['info']['serviceCode'];
		$agent = new AgentAide(1,$api_access);
		$t = $agent->servant;
		try{
			$json_obj = json_decode($t->get_self_key($service_code,$service_pwd),true);
		}catch(\Exception $e){
			$this->info = $e->getMessage();
			return false;
		}
		if(empty($json_obj) || strcmp($json_obj['code'],'0') != 0){
			$this->info = "跳转自主管理平台错误！";
			return false;
		}
		$url = C('SSP_SITE_URL');
		return '<html><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><body></body><script type="text/javascript">
		var postForm = document.createElement("form");
		postForm.method="post";
		postForm.style.display = "none";
		postForm.action ="'.$url.'";
		var codeInput = document.createElement("input");
		codeInput.setAttribute("type","text");
		codeInput.setAttribute("name","code");
		codeInput.setAttribute("value","'.$json_obj['info'].'");
		postForm.appendChild(codeInput);
		document.body.appendChild(postForm);
		postForm.submit();</script></html>';
	}
	
	/**
	 * 返回错误信息
	 * @时间: 2016年12月17日 下午3:09:18
	 * @author: duanbin
	 * @return string
	 */
	public function getInfo(){
		return $this->info;
	}
	
	/**
	 * 设置错误信息
	 * @时间: 2016年12月17日 下午3:09:53
	 * @author: duanbin
	 * @param $info
	 */
	public function setInfo($info){
		$this->info = $info;
	}

	/**
	 * 获取域名证书
	 * @时间: 2018年2月5日10:29:20
	 * @param $domainname
	 * @param $api_access
	 * @return bool
	 */
	public function get_domain_credentials($domainname,$api_access){
		$api_access = $api_access + 0;
		$api_access = $api_access == 2 ? $api_access : 1;
		if(empty($domainname)){
			$this->info = "域名信息获取失败!";
			return false;
		}
		$agent = new AgentAide(1,$api_access);
		$t = $agent->servant;
		try{
			$json_obj = json_decode($t->get_domain_credentials($domainname),true);
		}catch(\Exception $e){
			api_log(session("user_id"),"ptype:domain--pname:getDomainCer--tid:15--domainname:".$domainname,$e->getMessage(),"获取域名证书失败");
			$this->info = $e->getMessage();
			return false;
		}
		if(empty($json_obj) || strcmp($json_obj['code'],'0') != 0){
			$this->info = "获取域名证书失败！";
			api_log(session("user_id"),"ptype:domain--pname:getDomainCer--tid:15--domainname:".$domainname,business_code($json_obj['code']),"获取域名证书失败");
			return false;
		}
		return $json_obj["info"];
	}
}