<?php
namespace Frontend\Controller;

use Frontend\Controller\FrontendController;
use Frontend\Model\MemberModel;
use Common\Aide\ImagesAide;

/**
 * 前台首页
 * @author: Lyubo
 * @时间: 2016年10月21日 下午15:56:08
 */
class LoginController extends FrontendController{

	protected $captcha_type_regist = 'frontend_register';
	protected $captcha_type_login = 'frontend_sign_in';
	protected $model = null;

	public function _initialize(){
		parent::_initialize();
		$this->model = new MemberModel();
	}

	/**
	 * 前台登录页面
	 * @时间: 2016年10月24日 18:19:52
	 * @author: Lyubo
	 */
	public function login(){
		if (session('?user_id')) {
			redirect(U('index/index'),0,'');
			die();
		}
		if (IS_POST) {
			$user = new MemberModel();
			$date = request(true);
			$request['captcha'] = $date['captcha'];
			$request['type'] = $this->captcha_type_login;
			$where['login_name'] = array("eq",$date['user_name']);
			$result = $user->get_member_info($where);
			$imagesAide = new ImagesAide();
			$captcha_res = $imagesAide->checkCaptcha($request['captcha'],$request['type']);
			if (!$captcha_res){
				$msg = "验证码不对哦!";
				if(IS_AJAX){
					$this->error($msg, U("Login/login"), true);
				}else{
					$this->error($msg,U("Login/login"));
				}
			}
			if($result){
				$url = session("?backward") ? session("backward") : U("Member/index");
				$ym = "http://".$_SERVER['HTTP_HOST']."/";//获取当前域名
				if($url == $ym){
					$url = U("Member/index");
				}
				if(stripos(strtolower($url),"/frontend/index/index") !== false){
					$url = U("Member/index");
				}
				if(stripos(strtolower($url),"/index/index") !== false){
					$url = U("Member/index");
				}
				if(stripos(strtolower($url),"/frontend/login/login") !== false){
					$url = U("Member/index");
				}
				if(stripos(strtolower($url),"/login/login") !== false){
					$url = U("Member/index");
				}
				//验证数据库中去出的密码是否一致
				if($result['user_pass'] == pwd($result['login_name'],md5($date['user_pass']))){
					/*验证用户状态*/
					if ($result['user_state'] == 1){
						session('user_id',$result['user_id']);
						session('user_name',$result['user_name']);
						session('login_name',$result['login_name']);
						if(IS_AJAX){
							$this->success("登录成功",$url,true);
						}else{
							$this->success("登录成功",$url);
						}
					}else {
						if(IS_AJAX){
							$this->error("该用户状态异常",U("Login/login"),true);
						}else{
							$this->error("该用户状态异常",U("Login/login"));
						}
					}
				}else{
					if(IS_AJAX){
						$this->error("用户密码错误",U("Login/login"),true);
					}else{
						$this->error("用户密码错误",U("Login/login"));
					}
				}
			}else{
				if(IS_AJAX){
					$this->error("该用户未注册,请注册后登录",U("Login/login"),true);
				}else{
					$this->error("该用户未注册,请注册后登录",U("Login/login"));
				}
			}
		} else {
			$this->display();
		}
	}

	/**
	 * 前台退出
	 * @时间: 2016年10月24日 18:20:20
	 * @author: Lyubo
	 */
	public function logout(){
		session(null);
		redirect(U('/'),0,'');
	}

	/**
	 * 注册页面
	 * @时间: 2016年12月6日 下午5:30:22
	 * @author: duanbin
	 */
	public function register(){
		$this->display();
	}

	/**
	 * 处理注册逻辑
	 * @时间: 2016年12月7日 上午10:31:25
	 * @author: duanbin
	 */
	public function clerk(){
		$request = request(true);
		//验证码的标识
		$request['type'] = $this->captcha_type_regist;
		$res = $this->model->regist($request);
		if ($res === false) {
			$msg = $this->model->getError();
			if (IS_AJAX) {
				$this->error($msg, '',true);
			}else {
				$this->error($msg);
			}
		}else {
			session('user_id',$res['user_id']);
			session('user_name',$res['user_name']);
			session('login_name',$res['login_name']);
			$msg = '欢迎您注册为会员！:)';
			$url = U('member/index',[],false);
			if (IS_AJAX) {
				$this->success($msg, $url, true);
			}else {
				$this->success($msg, $url);
			}
		}
	}


	/**
	 * 登录和注册获取验证码的方法
	 * @时间: 2016年12月1日 上午10:04:36
	 * @author: duanbin
	 */
	public function captcha(){
		$request = request(true);
		$imagesAide = new ImagesAide();
		$imagesAide->capthca($request['type']);
	}

	/**
	 * 通过邮箱找回密码
	 * @date: 2017年2月20日 下午3:21:12
	 * @author: Lyubo
	 * @param: variable
	 */
	public function find_pass() {
		$this->display();
	}

	/**
	 * 检测用户是否注册
	 * @date: 2017年4月21日 下午6:18:56
	 * @author: Lyubo
	 * @param: variable
	 */
	public function checkLogin(){
		$request = request(true);
		$res = $this->model->checkLogin($request);
		if (IS_AJAX) {
			if ($res !== false) {
				$msg = "登录名可用！";
				$this->success($msg, '', true);
			}else {
				$msg = $this->model->getError();
				$this->error($msg, '',true);
			}
		}else{
			$msg = '请求方式错误';
			$this->error($msg, '');
		}
	}

	/**
	 * 检测用户是否存在
	 * @date: 2017年7月7日 上午10:39:56
	 * @author: Guopeng
	 */
	public function check_user(){
		$request = request(true);
		$user = new MemberModel();
		$res = $user->check_user($request);
		if (IS_AJAX) {
			if ($res !== false) {
				$this->success('用户验证成功','',$res);
			}else {
				$msg = $user->getError();
				$this->error($msg,'',true);
			}
		}else{
			$msg = '请求方式错误!';
			$this->error($msg,'');
		}
	}

	/**
	 * 发送验证邮件
	 * @author: Guopeng
	 * return: ajax\json
	 */
	public function send_mail(){
		if(IS_POST){
			$member = new MemberModel();
			$result = $member->sendMail();
			if($result !== false){
				$msg = "验证码发送成功，请在30分钟内使用！";
				$this->success($msg,"",true);
			}else{
				$msg = $member->getError();
				$this->error($msg,"",true);
			}
		}else{
			$this->_empty();
		}
	}

	/**
	 * 验证邮箱验证码
	 * @date: 2017年7月7日 下午17:26:55
	 * @author: Guopeng
	 */
	public function check_mail_code(){
		$member = new MemberModel();
		$result = $member->check_mail_code();
		if($result !== false){
			$msg = "邮箱验证码验证成功！";
			$this->success($msg,"",$result);
		}else{
			$msg = $member->getError();
			$this->error($msg,"",true);
		}
	}

	/**
	 * 重置密码
	 * @date: 2017年7月10日 上午10:26:55
	 * @author: Guopeng
	 */
	public function update_pass(){
		$member = new MemberModel();
		$result = $member->check_mail_code();
		if($result !== false){
			$msg = "密码重置成功！";
			$this->success($msg,U("login/login","",false),true);
		}else{
			$msg = $member->getError();
			$this->error($msg,"",true);
		}
	}

	/**
	 * QQ第三方登录
	 * @date: 2017年9月20日 下午17:16:55
	 * @author: Guopeng
	 */
	public function QQ_login(){
		$system = WebSiteConfig(9);
		$request = request();
		//应用的APPID
		$app_id = $system["login_qq_appid"];
		//应用的APPKEY
		$app_secret = $system["login_qq_appkey"];
		//成功授权后的回调地址
		$my_url = $system["login_qq_callback"];
		//Step1：获取Authorization Code
		$code = $request["code"];
		if(empty($code)){
			//state参数用于防止CSRF攻击，成功授权后回调时会原样带回
			$state = md5(uniqid(rand(), TRUE));
			session('state',$state);
			//拼接URL
			$dialog_url = "https://graph.qq.com/oauth2.0/authorize?response_type=code&client_id="
				.$app_id."&redirect_uri=".urlencode($my_url)."&state=".$state;
			header("Location:$dialog_url");
		}
		//Step2：通过Authorization Code获取Access Token
		if($request['state'] == session('state')){
			//拼接URL
			$token_url = "https://graph.qq.com/oauth2.0/token?grant_type=authorization_code&"."client_id="
				.$app_id."&redirect_uri=".urlencode($my_url)."&client_secret=".$app_secret."&code=".$code;
			$response = file_get_contents($token_url);
			if(strpos($response,"callback") !== false){
				$lpos = strpos($response,"(");
				$rpos = strrpos($response,")");
				$response = substr($response,$lpos + 1,$rpos - $lpos - 1);
				$msg = json_decode($response);
				if(isset($msg->error)){
					$this->error($msg->error.$msg->error_description);
				}
			}
			//Step3：使用Access Token来获取用户的OpenID
			$params = array();
			parse_str($response,$params);
			$graph_url = "https://graph.qq.com/oauth2.0/me?access_token=".$params['access_token'];
			$str = file_get_contents($graph_url);
			if(strpos($str,"callback") !== false){
				$lpos = strpos($str,"(");
				$rpos = strrpos($str,")");
				$str = substr($str,$lpos + 1,$rpos - $lpos - 1);
			}
			$user = json_decode($str);
			if(isset($user->error)){
				$this->error($user->error.$user->error_description);
			}
			$member = new \Frontend\Model\MemberModel();
			$result = $member->QQ_logon($user);
			if($result !== false){
				$url = U("Member/index");
				$msg = "登录成功！";
				$this->success($msg,$url);
			}else{
				$msg = $member->getError();
				$this->error($msg);
			}
		}else{
			$this->error("The state does not match. You may be a victim of CSRF.");
		}
	}

	/**
	 * 注册发送验证码
	 * @date 2017年10月17日 15:37:05
	 * @author: Guopeng
	 */
	public function register_sendMail(){
		$member = new MemberModel();
		$result = $member->register_sendMail();
		if($result === true){
			$msg = "验证码发送成功，请在30分钟内使用！";
			$this->success($msg,"",true);
		}else{
			$msg = $member->getError();
			$this->error($msg,"",true);
		}
	}
}